// Copyright (c) 2013, the Dart project authors.  Please see the AUTHORS file
// for details. All rights reserved. Use of this source code is governed by a
// BSD-style license that can be found in the LICENSE file.

library trydart.mock;

const List<String> identifiers = const <String>[
    "ATTRIBUTE_NODE",
    "AnalyserNode",
    "ApplicationCache",
    "Array",
    "ArrayBuffer",
    "Attr",
    "Audio",
    "AudioBuffer",
    "AudioBufferSourceNode",
    "AudioDestinationNode",
    "AudioListener",
    "AudioNode",
    "AudioParam",
    "AudioProcessingEvent",
    "AutocompleteErrorEvent",
    "BarProp",
    "BeforeUnloadEvent",
    "BiquadFilterNode",
    "Blob",
    "Boolean",
    "CDATASection",
    "CDATA_SECTION_NODE",
    "COMMENT_NODE",
    "CSS",
    "CSSCharsetRule",
    "CSSFontFaceRule",
    "CSSImportRule",
    "CSSKeyframeRule",
    "CSSKeyframesRule",
    "CSSMediaRule",
    "CSSPageRule",
    "CSSPrimitiveValue",
    "CSSRule",
    "CSSRuleList",
    "CSSStyleDeclaration",
    "CSSStyleRule",
    "CSSStyleSheet",
    "CSSValue",
    "CSSValueList",
    "CSSViewportRule",
    "CanvasGradient",
    "CanvasPattern",
    "CanvasRenderingContext2D",
    "ChannelMergerNode",
    "ChannelSplitterNode",
    "CharacterData",
    "ClientRect",
    "ClientRectList",
    "Clipboard",
    "CloseEvent",
    "Comment",
    "CompositionEvent",
    "ConvolverNode",
    "Counter",
    "CustomEvent",
    "DOCUMENT_FRAGMENT_NODE",
    "DOCUMENT_NODE",
    "DOCUMENT_POSITION_CONTAINED_BY",
    "DOCUMENT_POSITION_CONTAINS",
    "DOCUMENT_POSITION_DISCONNECTED",
    "DOCUMENT_POSITION_FOLLOWING",
    "DOCUMENT_POSITION_IMPLEMENTATION_SPECIFIC",
    "DOCUMENT_POSITION_PRECEDING",
    "DOCUMENT_TYPE_NODE",
    "DOMException",
    "DOMImplementation",
    "DOMParser",
    "DOMSettableTokenList",
    "DOMStringList",
    "DOMStringMap",
    "DOMTokenList",
    "DataTransferItemList",
    "DataView",
    "Date",
    "DelayNode",
    "DeviceMotionEvent",
    "DeviceOrientationEvent",
    "Document",
    "DocumentFragment",
    "DocumentType",
    "DynamicsCompressorNode",
    "ELEMENT_NODE",
    "ENTITY_NODE",
    "ENTITY_REFERENCE_NODE",
    "Element",
    "Error",
    "ErrorEvent",
    "EvalError",
    "Event",
    "EventSource",
    "EventTarget",
    "File",
    "FileError",
    "FileList",
    "FileReader",
    "Float32Array",
    "Float64Array",
    "FocusEvent",
    "FormData",
    "Function",
    "GainNode",
    "HTMLAllCollection",
    "HTMLAnchorElement",
    "HTMLAppletElement",
    "HTMLAreaElement",
    "HTMLAudioElement",
    "HTMLBRElement",
    "HTMLBaseElement",
    "HTMLBodyElement",
    "HTMLButtonElement",
    "HTMLCanvasElement",
    "HTMLCollection",
    "HTMLContentElement",
    "HTMLDListElement",
    "HTMLDataListElement",
    "HTMLDirectoryElement",
    "HTMLDivElement",
    "HTMLDocument",
    "HTMLElement",
    "HTMLEmbedElement",
    "HTMLFieldSetElement",
    "HTMLFontElement",
    "HTMLFormControlsCollection",
    "HTMLFormElement",
    "HTMLFrameElement",
    "HTMLFrameSetElement",
    "HTMLHRElement",
    "HTMLHeadElement",
    "HTMLHeadingElement",
    "HTMLHtmlElement",
    "HTMLIFrameElement",
    "HTMLImageElement",
    "HTMLInputElement",
    "HTMLKeygenElement",
    "HTMLLIElement",
    "HTMLLabelElement",
    "HTMLLegendElement",
    "HTMLLinkElement",
    "HTMLMapElement",
    "HTMLMarqueeElement",
    "HTMLMediaElement",
    "HTMLMenuElement",
    "HTMLMetaElement",
    "HTMLMeterElement",
    "HTMLModElement",
    "HTMLOListElement",
    "HTMLObjectElement",
    "HTMLOptGroupElement",
    "HTMLOptionElement",
    "HTMLOptionsCollection",
    "HTMLOutputElement",
    "HTMLParagraphElement",
    "HTMLParamElement",
    "HTMLPreElement",
    "HTMLProgressElement",
    "HTMLQuoteElement",
    "HTMLScriptElement",
    "HTMLSelectElement",
    "HTMLShadowElement",
    "HTMLSourceElement",
    "HTMLSpanElement",
    "HTMLStyleElement",
    "HTMLTableCaptionElement",
    "HTMLTableCellElement",
    "HTMLTableColElement",
    "HTMLTableElement",
    "HTMLTableRowElement",
    "HTMLTableSectionElement",
    "HTMLTemplateElement",
    "HTMLTextAreaElement",
    "HTMLTitleElement",
    "HTMLTrackElement",
    "HTMLUListElement",
    "HTMLUnknownElement",
    "HTMLVideoElement",
    "HashChangeEvent",
    "History",
    "IDBCursor",
    "IDBCursorWithValue",
    "IDBDatabase",
    "IDBFactory",
    "IDBIndex",
    "IDBKeyRange",
    "IDBObjectStore",
    "IDBOpenDBRequest",
    "IDBRequest",
    "IDBTransaction",
    "IDBVersionChangeEvent",
    "Image",
    "ImageBitmap",
    "ImageData",
    "Infinity",
    "InputMethodContext",
    "Int16Array",
    "Int32Array",
    "Int8Array",
    "Intl",
    "JSON",
    "KeyboardEvent",
    "Location",
    "Math",
    "MediaController",
    "MediaElementAudioSourceNode",
    "MediaError",
    "MediaKeyError",
    "MediaKeyEvent",
    "MediaList",
    "MediaSource",
    "MediaStreamAudioDestinationNode",
    "MediaStreamAudioSourceNode",
    "MediaStreamEvent",
    "MediaStreamTrack",
    "MessageChannel",
    "MessageEvent",
    "MessagePort",
    "MimeType",
    "MimeTypeArray",
    "MouseEvent",
    "MutationEvent",
    "MutationObserver",
    "MutationRecord",
    "NOTATION_NODE",
    "NaN",
    "NamedNodeMap",
    "Navigator",
    "Node",
    "NodeFilter",
    "NodeIterator",
    "NodeList",
    "Notation",
    "Notification",
    "Number",
    "Object",
    "OfflineAudioCompletionEvent",
    "Option",
    "OscillatorNode",
    "OverflowEvent",
    "PROCESSING_INSTRUCTION_NODE",
    "PageTransitionEvent",
    "Performance",
    "PerformanceEntry",
    "PerformanceMark",
    "PerformanceMeasure",
    "PerformanceNavigation",
    "PerformanceResourceTiming",
    "PerformanceTiming",
    "PeriodicWave",
    "Plugin",
    "PluginArray",
    "PopStateEvent",
    "ProcessingInstruction",
    "ProgressEvent",
    "Promise",
    "RGBColor",
    "RTCIceCandidate",
    "RTCSessionDescription",
    "Range",
    "RangeError",
    "Rect",
    "ReferenceError",
    "RegExp",
    "SVGAElement",
    "SVGAltGlyphDefElement",
    "SVGAltGlyphElement",
    "SVGAltGlyphItemElement",
    "SVGAngle",
    "SVGAnimateElement",
    "SVGAnimateMotionElement",
    "SVGAnimateTransformElement",
    "SVGAnimatedAngle",
    "SVGAnimatedBoolean",
    "SVGAnimatedEnumeration",
    "SVGAnimatedInteger",
    "SVGAnimatedLength",
    "SVGAnimatedLengthList",
    "SVGAnimatedNumber",
    "SVGAnimatedNumberList",
    "SVGAnimatedPreserveAspectRatio",
    "SVGAnimatedRect",
    "SVGAnimatedString",
    "SVGAnimatedTransformList",
    "SVGAnimationElement",
    "SVGCircleElement",
    "SVGClipPathElement",
    "SVGComponentTransferFunctionElement",
    "SVGCursorElement",
    "SVGDefsElement",
    "SVGDescElement",
    "SVGDiscardElement",
    "SVGElement",
    "SVGElementInstance",
    "SVGElementInstanceList",
    "SVGEllipseElement",
    "SVGFEBlendElement",
    "SVGFEColorMatrixElement",
    "SVGFEComponentTransferElement",
    "SVGFECompositeElement",
    "SVGFEConvolveMatrixElement",
    "SVGFEDiffuseLightingElement",
    "SVGFEDisplacementMapElement",
    "SVGFEDistantLightElement",
    "SVGFEDropShadowElement",
    "SVGFEFloodElement",
    "SVGFEFuncAElement",
    "SVGFEFuncBElement",
    "SVGFEFuncGElement",
    "SVGFEFuncRElement",
    "SVGFEGaussianBlurElement",
    "SVGFEImageElement",
    "SVGFEMergeElement",
    "SVGFEMergeNodeElement",
    "SVGFEMorphologyElement",
    "SVGFEOffsetElement",
    "SVGFEPointLightElement",
    "SVGFESpecularLightingElement",
    "SVGFESpotLightElement",
    "SVGFETileElement",
    "SVGFETurbulenceElement",
    "SVGFilterElement",
    "SVGFontElement",
    "SVGFontFaceElement",
    "SVGFontFaceFormatElement",
    "SVGFontFaceNameElement",
    "SVGFontFaceSrcElement",
    "SVGFontFaceUriElement",
    "SVGForeignObjectElement",
    "SVGGElement",
    "SVGGeometryElement",
    "SVGGlyphElement",
    "SVGGlyphRefElement",
    "SVGGradientElement",
    "SVGGraphicsElement",
    "SVGHKernElement",
    "SVGImageElement",
    "SVGLength",
    "SVGLengthList",
    "SVGLineElement",
    "SVGLinearGradientElement",
    "SVGMPathElement",
    "SVGMarkerElement",
    "SVGMaskElement",
    "SVGMatrix",
    "SVGMetadataElement",
    "SVGMissingGlyphElement",
    "SVGNumber",
    "SVGNumberList",
    "SVGPathElement",
    "SVGPathSeg",
    "SVGPathSegArcAbs",
    "SVGPathSegArcRel",
    "SVGPathSegClosePath",
    "SVGPathSegCurvetoCubicAbs",
    "SVGPathSegCurvetoCubicRel",
    "SVGPathSegCurvetoCubicSmoothAbs",
    "SVGPathSegCurvetoCubicSmoothRel",
    "SVGPathSegCurvetoQuadraticAbs",
    "SVGPathSegCurvetoQuadraticRel",
    "SVGPathSegCurvetoQuadraticSmoothAbs",
    "SVGPathSegCurvetoQuadraticSmoothRel",
    "SVGPathSegLinetoAbs",
    "SVGPathSegLinetoHorizontalAbs",
    "SVGPathSegLinetoHorizontalRel",
    "SVGPathSegLinetoRel",
    "SVGPathSegLinetoVerticalAbs",
    "SVGPathSegLinetoVerticalRel",
    "SVGPathSegList",
    "SVGPathSegMovetoAbs",
    "SVGPathSegMovetoRel",
    "SVGPatternElement",
    "SVGPoint",
    "SVGPointList",
    "SVGPolygonElement",
    "SVGPolylineElement",
    "SVGPreserveAspectRatio",
    "SVGRadialGradientElement",
    "SVGRect",
    "SVGRectElement",
    "SVGRenderingIntent",
    "SVGSVGElement",
    "SVGScriptElement",
    "SVGSetElement",
    "SVGStopElement",
    "SVGStringList",
    "SVGStyleElement",
    "SVGSwitchElement",
    "SVGSymbolElement",
    "SVGTSpanElement",
    "SVGTextContentElement",
    "SVGTextElement",
    "SVGTextPathElement",
    "SVGTextPositioningElement",
    "SVGTitleElement",
    "SVGTransform",
    "SVGTransformList",
    "SVGUnitTypes",
    "SVGUseElement",
    "SVGVKernElement",
    "SVGViewElement",
    "SVGViewSpec",
    "SVGZoomEvent",
    "Screen",
    "ScriptProcessorNode",
    "Selection",
    "SharedWorker",
    "SpeechInputEvent",
    "SpeechSynthesisEvent",
    "SpeechSynthesisUtterance",
    "Storage",
    "StorageEvent",
    "String",
    "StyleSheet",
    "StyleSheetList",
    "SyntaxError",
    "TEXT_NODE",
    "Text",
    "TextEvent",
    "TextMetrics",
    "TextTrack",
    "TextTrackCue",
    "TextTrackCueList",
    "TextTrackList",
    "TimeRanges",
    "Touch",
    "TouchEvent",
    "TouchList",
    "TrackEvent",
    "TransitionEvent",
    "TreeWalker",
    "TypeError",
    "UIEvent",
    "URIError",
    "URL",
    "Uint16Array",
    "Uint32Array",
    "Uint8Array",
    "Uint8ClampedArray",
    "VTTCue",
    "ValidityState",
    "WaveShaperNode",
    "WebGLActiveInfo",
    "WebGLBuffer",
    "WebGLContextEvent",
    "WebGLFramebuffer",
    "WebGLProgram",
    "WebGLRenderbuffer",
    "WebGLRenderingContext",
    "WebGLShader",
    "WebGLShaderPrecisionFormat",
    "WebGLTexture",
    "WebGLUniformLocation",
    "WebSocket",
    "WheelEvent",
    "Window",
    "Worker",
    "XMLDocument",
    "XMLHttpRequest",
    "XMLHttpRequestProgressEvent",
    "XMLHttpRequestUpload",
    "XMLSerializer",
    "XPathEvaluator",
    "XPathExpression",
    "XPathResult",
    "XSLTProcessor",
    "activeElement",
    "addEventListener",
    "adoptNode",
    "alinkColor",
    "all",
    "anchors",
    "appendChild",
    "applets",
    "applicationCache",
    "baseURI",
    "bgColor",
    "body",
    "captureEvents",
    "caretRangeFromPoint",
    "characterSet",
    "charset",
    "childElementCount",
    "childNodes",
    "children",
    "chrome",
    "clear",
    "clientInformation",
    "cloneNode",
    "close",
    "closed",
    "compareDocumentPosition",
    "compatMode",
    "console",
    "contains",
    "cookie",
    "cr",
    "createAttribute",
    "createCDATASection",
    "createComment",
    "createDocumentFragment",
    "createElement",
    "createElementNS",
    "createEvent",
    "createExpression",
    "createNSResolver",
    "createNodeIterator",
    "createProcessingInstruction",
    "createRange",
    "createTextNode",
    "createTreeWalker",
    "crypto",
    "currentScript",
    "decodeURI",
    "decodeURIComponent",
    "defaultCharset",
    "defaultStatus",
    "defaultView",
    "defaultstatus",
    "designMode",
    "devicePixelRatio",
    "dir",
    "dispatchEvent",
    "doctype",
    "document",
    "documentElement",
    "documentURI",
    "domain",
    "elementFromPoint",
    "embeds",
    "encodeURI",
    "encodeURIComponent",
    "escape",
    "eval",
    "evaluate",
    "event",
    "execCommand",
    "external",
    "fgColor",
    "firstChild",
    "firstElementChild",
    "forms",
    "frameElement",
    "frames",
    "getCSSCanvasContext",
    "getElementById",
    "getElementsByClassName",
    "getElementsByName",
    "getElementsByTagName",
    "getElementsByTagNameNS",
    "getOverrideStyle",
    "getSelection",
    "global",
    "hasChildNodes",
    "hasFocus",
    "head",
    "hidden",
    "history",
    "i18nTemplate",
    "images",
    "implementation",
    "importNode",
    "indexedDB",
    "innerHeight",
    "innerWidth",
    "inputEncoding",
    "insertBefore",
    "isDefaultNamespace",
    "isEqualNode",
    "isFinite",
    "isNaN",
    "isSameNode",
    "lastChild",
    "lastElementChild",
    "lastModified",
    "length",
    "linkColor",
    "links",
    "localName",
    "localStorage",
    "location",
    "locationbar",
    "lookupNamespaceURI",
    "lookupPrefix",
    "menubar",
    "name",
    "namespaceURI",
    "navigator",
    "nextSibling",
    "nodeName",
    "nodeType",
    "nodeValue",
    "normalize",
    "ntp",
    "offscreenBuffering",
    "onabort",
    "onbeforecopy",
    "onbeforecut",
    "onbeforepaste",
    "onblur",
    "oncancel",
    "oncanplay",
    "oncanplaythrough",
    "onchange",
    "onclick",
    "onclose",
    "oncontextmenu",
    "oncopy",
    "oncuechange",
    "oncut",
    "ondblclick",
    "ondrag",
    "ondragend",
    "ondragenter",
    "ondragleave",
    "ondragover",
    "ondragstart",
    "ondrop",
    "ondurationchange",
    "onemptied",
    "onended",
    "onerror",
    "onfocus",
    "oninput",
    "oninvalid",
    "onkeydown",
    "onkeypress",
    "onkeyup",
    "onload",
    "onloadeddata",
    "onloadedmetadata",
    "onloadstart",
    "onmousedown",
    "onmouseenter",
    "onmouseleave",
    "onmousemove",
    "onmouseout",
    "onmouseover",
    "onmouseup",
    "onmousewheel",
    "onpaste",
    "onpause",
    "onplay",
    "onplaying",
    "onprogress",
    "onratechange",
    "onreadystatechange",
    "onreset",
    "onresize",
    "onscroll",
    "onsearch",
    "onseeked",
    "onseeking",
    "onselect",
    "onselectionchange",
    "onselectstart",
    "onshow",
    "onstalled",
    "onsubmit",
    "onsuspend",
    "ontimeupdate",
    "onvolumechange",
    "onwaiting",
    "onwheel",
    "open",
    "opener",
    "outerHeight",
    "outerWidth",
    "ownerDocument",
    "pageXOffset",
    "pageYOffset",
    "parent",
    "parentElement",
    "parentNode",
    "parseFloat",
    "parseInt",
    "performance",
    "personalbar",
    "plugins",
    "preferredStylesheetSet",
    "previousSibling",
    "queryCommandEnabled",
    "queryCommandIndeterm",
    "queryCommandState",
    "queryCommandSupported",
    "queryCommandValue",
    "querySelector",
    "querySelectorAll",
    "readyState",
    "referrer",
    "registerElement",
    "releaseEvents",
    "removeChild",
    "removeEventListener",
    "replaceChild",
    "rootElement",
    "screen",
    "screenLeft",
    "screenTop",
    "screenX",
    "screenY",
    "scripts",
    "scrollX",
    "scrollY",
    "scrollbars",
    "selectedStylesheetSet",
    "self",
    "sessionStorage",
    "speechSynthesis",
    "status",
    "statusbar",
    "styleMedia",
    "styleSheets",
    "templateData",
    "textContent",
    "title",
    "toolbar",
    "top",
    "undefined",
    "unescape",
    "visibilityState",
    "vlinkColor",
    "window",
    "write",
    "writeln",
    "xmlEncoding",
    "xmlStandalone",
    "xmlVersion",
  ];
